<template>
	<div>
		<NavbarTop></NavbarTop>
		<h2>API Data Fetching</h2>
		<div class="container">
			<label for="cityName">Weather for city:</label>
			<input id="cityName" v-model="city" type="text" placeholder="Gliwice, PL">
			<button id="callAPI" @click="callToAPI">Get data</button>
			<ul v-if="responseObject">
				<h3>City: {{ responseObject.city.name }} ({{ responseObject.city.country }})</h3>
				<li class="tile" v-for="(day, index) in responseObject.list">
					<h2>Forecast for {{ getNewDate(index) }}</h2>
					<p>Weather: {{ day.weather[0].main }} ({{ day.weather[0].description }})</p>
					<span>Humidity: {{ day.main.humidity }}</span> <span>Pressure: {{ Math.round(day.main.pressure) }} (hPa)</span>
				</li>
			</ul>
			<p id="result">
			</p>
		</div>
	</div>
</template>

<script>
	import NavbarTop from '@/components/NavbarTop'
	export default {
		components: {
			NavbarTop
		},
		data () {
			return {
				city: 'Gliwice, PL',
				responseObject: false,
				currentDate: Date.now()
			}
		},
		methods: {
			callToAPI () {
				var vm = this;
				var xmlhttp = new XMLHttpRequest();
				xmlhttp.onreadystatechange = function() {
					if (this.readyState == 4 && this.status == 200) {
						vm.responseObject = JSON.parse(this.responseText);
					}
				};
				xmlhttp.open("GET", "http://api.openweathermap.org/data/2.5/forecast?q=" + vm.city + "&APPID=4ff74cb01b04a2f3b840b48ddefedb79", true);
				xmlhttp.send();
			},
			getNewDate(multiplier) {
				var vm = this
				var newDateInMillis = vm.currentDate + 86400000 * parseInt(multiplier)
				var newDate = new Date(newDateInMillis)
				var day = newDate.getDate()
				var month = newDate.getMonth() + 1
				if (day < 10)
					day = "0" + day
				if (month < 10)
					month = "0" + month
				return [day, month, newDate.getFullYear()].join('-')
			}
		},
		mounted () {
			this.callToAPI()
		}
	}
</script>

<style scoped>
	li {
		list-style-type: none;
	}
	.tile {
		margin-bottom: 2px;
		background-color: rgba(0, 0, 0, 0.1);
		transition: all 0.2s ease-in-out;
	}
	.tile:hover {
		transform: translate3d(3px, -5px, -2px);
		box-shadow: 0 0.2rem 1rem 0 rgba(149,163,176,0.75);
		transition: all 0.2s ease-in-out;
	}
</style>
